%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%



domains

lista=integer*

listy=lista*



%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%



predicates

zagadka(listy)

member(integer,lista)

kazdy_Inny(lista)

numer(integer,lista,lista)

numer(integer)



%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%



clauses



% okrelanie numeru ktry jeszcze nie wystpi

% rzeczy danej klasy musz by rozmieszczone

% kada w innym domu std kolejne przyporzdkowanie

% powinno by rne od wszystkich poprzednich

numer(X,[],[X]):-

	numer(X),!.

numer(X,Acc,[X|Acc]):-

	numer(X),not(member(X,Acc)).



% Moliwe numery

% W zadaniu mowa jest o piciu domach

numer(1).

numer(2).

numer(3).

numer(4).

numer(5).



% sprawdzanie dzy dany element naley do listy

member(H,[H|_]).

member(H,[_|T]):-

	member(H,T).



% sprawdzenie czy wszystkie elementy listy

% s rne midzy sob. Suy do sprawdzenia

% czy rzeczy danej klasy s rozmieszczone

% kada w innym domu

kazdy_Inny([_|[]]):-!.

kazdy_Inny([H|T]):-

	not(member(H,T)),kazdy_Inny(T).



% Rozwizanie zagadki

% W wyniku otrzymujemy 5 list z ktrych elementy

% kadej listy mwi nam w ktrym domu

% znajduje si dana rzecz i tak:

% pierwsza lista mwi w ktrych domach mieszkaj:

% Anglik, Norweg, Duczyk, Szwed, Niemiec

% (pierszy element pierwszej listy mwi o numerze

% domu Anglika, drugi Norwega, itd.)

% druga lista to kolory domw:

% Czerwony, ty, Niebieski, Zielony, Biay

% trzecia lista to rozmieszczenie papierosw

% Rothmans, Dunhill, Marlboro, Pall Mall, Philip Morris

% czwarta o chodowanych w domach zwierztach:

% Kot, Ptak, Ko, Pies, Rybka

% pita o tym jaki napj w danym domu si pija:

% Herbata, Mleko, Woda, Piwo, Kawa



zagadka(Wynik):-

	Norweg=1,

	numer(Anglik,[1],N1),

	numer(Dunczyk,N1,N2),

	numer(Szwed,N2,N3),

	numer(Niemiec,N3,_),

	Narodowosc=[Anglik,Norweg,Dunczyk,Szwed,Niemiec],



	Czerwony=Anglik,

	numer(Zielony,[Czerwony,5],_),

	Bialy=Zielony+1,

	numer(Zolty,[Czerwony,Bialy,Zielony],K2),

	numer(Niebieski,K2,_),

	Kolor=[Czerwony,Zolty,Niebieski,Zielony,Bialy],

	kazdy_Inny(Kolor),



	Dunhill=Zolty,

	Marlboro=Niemiec,

	numer(Rothmans,[Dunhill,Marlboro],P2),

	numer(Pall_Mall,P2,P3),

	numer(Philip_Morris,P3,_),

	Papierosy=[Rothmans,Dunhill,Marlboro,Pall_Mall,Philip_Morris],

	kazdy_Inny(Papierosy),



	Pies=Szwed,

	Ptak=Pall_Mall,

	numer(Kot,[Ptak,Pies],Z2),

	numer(Kon,Z2,Z3),

	numer(Rybka,Z3,_),

	Zwierze=[Kot,Ptak,Kon,Pies,Rybka],

	kazdy_Inny(Zwierze),



	Herbata=Dunczyk,

	Mleko=3,

	Piwo=Philip_Morris,

	Kawa=Zielony,

	numer(Woda,[Herbata,Mleko,Piwo,Kawa],_),

	Napoj=[Herbata,Mleko,Woda,Piwo,Kawa],

	kazdy_Inny(Napoj),



	Wynik=[Narodowosc,Kolor,Papierosy,Zwierze,Napoj],

	R1=Rothmans-Kot,R1W=abs(R1),R1W=1,

	R2=Rothmans-Woda,R2W=abs(R2),R2W=1, 

	R3=Norweg-Niebieski,R3W=abs(R3),R3W=1,

	R4=Kon-Zolty,R4W=abs(R4),R4W=1.